package com.zksy.visualization.controller.smartElectricController;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.zksy.common.core.domain.Result;
import com.zksy.visualization.config.IccConfigProperty;
import com.zksy.visualization.domain.request.ComprehensiveRequest;
import com.zksy.visualization.domain.response.ComprehensiveResponse;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import okhttp3.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;

/**
 * @author Administrator
 * @version 1.0
 * @project dh-server-micro
 * @description 智慧用电-综合查询（用于查询空开的电流、电压、温度、功率情况）
 * @date 2024/12/16 14:45:27
 */
@RestController
@Api(tags = "智慧用电-综合查询", description = "智慧用电-综合查询")
@RequestMapping("/comprehensive")
@Slf4j
public class ComprehensiveController {
    @Autowired
    private IccConfigProperty iccConfigProperty;
    @Autowired
    private OkHttpClient httpClient;
    @Autowired
    private RedisTemplate<String,String> redisTemplate;

    private static final MediaType JSON = MediaType.parse("application/json; charset=utf-8");

    @ApiOperation(value = "综合查询（用于查询空开的电流、电压、温度、功率情况）")
    @PostMapping("/comprehensiveQuery")
    public Result comprehensive(ComprehensiveRequest request){
        ObjectMapper objectMapper = new ObjectMapper();
        String jsonParams = null;
        String authorization = redisTemplate
                .opsForValue()
                .get("Authorization:" + iccConfigProperty.getUsername());
        try {
            jsonParams = objectMapper.writeValueAsString(request);
        } catch (JsonProcessingException e) {
            log.error("JSON序列化失败: {}", e);
            return Result.error("请求失败");
        }
        // 创建请求体
        RequestBody body = RequestBody.create(jsonParams, JSON);
        // 构建请求
        Request requestHttp = new Request.Builder()
                .url("https://" + iccConfigProperty.getHost() + "/evo-apigw/evo-electricity/"+ iccConfigProperty.getVersion() +"/history/getOtherData")
                .addHeader("Authorization", authorization)
                .post(body)
                .build();
        // 发送请求
        try (Response response = httpClient.newCall(requestHttp).execute()) {
            if (!response.isSuccessful()) {
                return Result.error("请求失败");
            }
            ResponseBody responseBody = response.body();
            if (responseBody != null) {
                String responseString = responseBody.string();
                JsonNode rootNode = objectMapper.readTree(responseString);
                JsonNode success = rootNode.path("success");
                if(success.isBoolean() && success.asBoolean()) {
                    JsonNode dataNode = rootNode.path("data");
                    if (dataNode.isObject()) {
                        ComprehensiveResponse comprehensiveResponse = objectMapper.treeToValue(dataNode, ComprehensiveResponse.class);
                        return Result.ok(comprehensiveResponse);
                    } else {
                        return Result.ok(null);
                    }
                }else {
                    JsonNode errMsgNode = rootNode.path("errMsg");
                    String errMsg = errMsgNode.isTextual() ? errMsgNode.asText() : "未知错误";
                    return Result.error(errMsg);
                }
            }
        } catch (IOException e) {
            log.error("请求失败: {}", e);
        }
        return Result.error("请求失败");
    }

/*    public ComprehensiveResponse getComprehensive(ComprehensiveRequest comprehensiveRequest){
        OauthConfigUserPwdInfo config = oauthConfigUtil.getOauthConfig();
        ComprehensiveResponse response=null;
        try {
            log.info("airConditioner,controlAirConditioner,request:{}", JSONUtil.toJsonStr(comprehensiveRequest));
            response = HttpUtils.executeJson("/evo-apigw/evo-electricity/"+ iccConfigProperty.getVersion() +"/history/getOtherData", comprehensiveRequest,null, Method.POST , config, ComprehensiveResponse.class);
            log.info("airConditioner,controlAirConditioner,response:{}", JSONUtil.toJsonStr(response));
        } catch (ClientException e) {
            log.error(e.getErrMsg(), e);
        }
        if(!response.isSuccess()) {
            log.info("综合查询失败:{}",response.getErrMsg());
        }
        return response;
    }*/

}
